// PolyTestDoc.cpp : CPolyTestDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "PolyTest.h"

#include "PolyTestDoc.h"
#include "PolyTestView.h"
#include "FileManager.h"
#include "LetterFunction.h"

#include "vtkSampleFunction.h"
#include "vtkStructuredPoints.h"
#include "vtkPoints.h"
#include "vtkCellType.h"
#include "OurImplicitFunction.h"
#include "vtkContourFilter.h"
#include "MeshData.h"
#include "math.h"
#include "Smoother.h"
#include "Subdivider.h"
#include "SmoothDialog.h"
#include "vtkVolume16Reader.h"
#include "vtkPolyDataMapper.h"
#include "VolumeFunction.h"
#include "vtkFloatScalars.h"
#include "vtkPNMReader.h"
#include "vtkImageShrink3D.h"
#include "vtkImageClip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPolyTestDoc

IMPLEMENT_DYNCREATE(CPolyTestDoc, CDocument)

BEGIN_MESSAGE_MAP(CPolyTestDoc, CDocument)
	//{{AFX_MSG_MAP(CPolyTestDoc)
	ON_COMMAND(ID_POLYGONIZE, OnPolygonize)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_WIRE, OnWire)
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_COMMAND(ID_FLAT, OnFlat)
	ON_COMMAND(ID_VOL, OnVol)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_SUBDIVIDE, OnSubdivide)
	ON_COMMAND(ID_SIMPLIFY, OnSimplify)
	ON_COMMAND(ID_ENGRAVE, OnEngrave)
	ON_COMMAND(ID_NABLA, OnNabla)
	ON_COMMAND(ID_UNIFORM, OnUniform)
	ON_COMMAND(ID_OPT, OnOpt)
	ON_COMMAND(ID_CENTR, OnCentr)
	ON_COMMAND(ID_FLIP, OnFlip)
	ON_COMMAND(ID_TOGETHER, OnTogether)
	ON_COMMAND(ID_COMP_T, OnCompT)
	ON_COMMAND(ID_RBF, OnRbf)
	ON_COMMAND(ID_SILVER, OnSilver)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static char file_ex[] = "All files(*.*)|*.*||";

/////////////////////////////////////////////////////////////////////////////
// CPolyTestDoc NX̍\z/

CPolyTestDoc::CPolyTestDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	mesh = NULL;
	smoother = new Smoother;
	subdivider = new Subdivider;
	simplifier = new Simplifier;
	s_dia = new SmoothDialog;
	all_dia = new AllDialog;
	uni_dia = new UniformDialog;
	grid_dia = new GridDialog;
	deci_dia = new DecimationDialog;
	time_dia = new TimeDialog;
	auto_dia = new AutoOptDialog;
	func = NULL;
	mode = 0;
	is_deformed = false;
}

CPolyTestDoc::~CPolyTestDoc()
{
	if(mesh != NULL)
		delete mesh;
	if(func != NULL)
		func->Delete();
	delete smoother;
	delete subdivider;
	delete simplifier;
	delete s_dia;
	delete deci_dia;
	delete time_dia;
	delete auto_dia;
}

BOOL CPolyTestDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	//OnPolygonize();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CPolyTestDoc VAC[[V

void CPolyTestDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPolyTestDoc NX̐ff

#ifdef _DEBUG
void CPolyTestDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPolyTestDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPolyTestDoc R}h

void CPolyTestDoc::OnPolygonize() 
{
	int dim;
	if(grid_dia->DoModal() == IDOK)
		dim = grid_dia->m_grid;
	else
		return;

	//return;
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	/***********************************************/
	//int dim = 50;
	/**********************************************/
	clock_t start = clock();

	if(func == NULL)
		//func->Delete();
		func = new OurImplicitFunction;
	//func = new LetterFunction;

	((OurImplicitFunction*)func)->count = 0;

	vtkSampleFunction *sample = vtkSampleFunction::New();
	sample->SetSampleDimensions(dim,dim,dim);
	//sample->SetSampleDimensions(((LetterFunction*)func)->sizeX, ((LetterFunction*)func)->sizeY, 10);
	//sample->SetModelBounds(-5,((LetterFunction*)func)->sizeX+10,-5,((LetterFunction*)func)->sizeY+10,-10.5,10.5);
	sample->SetModelBounds(-20,20,-20,20,-20,20);
	sample->SetImplicitFunction(func);
	sample->ComputeNormalsOff();
	sample->Update();

	vtkContourFilter *contour = vtkContourFilter::New();
	//contour->UseScalarTreeOn();
	//contour->ComputeNormalsOff();
	//contour->ComputeGradientsOff();
	//vtkMarchingCubes *contour = vtkMarchingCubes::New();
	contour->SetInput(sample->GetOutput());
	contour->GenerateValues(1, 0, 0);
	contour->Update();

	if(!grid_dia->m_opt){
		clock_t finish = clock();
		double duration = (double)(finish - start) / CLOCKS_PER_SEC;
		time_dia->m_time = duration;
		time_dia->m_count = ((OurImplicitFunction*)func)->count;
		//printf( "%2.1f seconds\n", duration );
	}

	vtkPolyData *mesh_data = contour->GetOutput();

	if(mesh != NULL)
		delete mesh;
	mesh = new MeshData;

	int vertex_N = mesh_data->GetNumberOfPoints();
	mesh->setVertexCount(vertex_N);

	for(int i=0; i<vertex_N; i++){
		mesh_data->GetPoint(i, mesh->vertex[i]);
	}

	int poly_N = mesh_data->GetNumberOfCells();
	mesh->setFaceCount(poly_N);

	int (*face)[3] = mesh->face;
	for(i=0; i<poly_N; i++){
		vtkCell* cell = mesh_data->GetCell(i);
		face[i][0] = cell->GetPointId(0);
		face[i][1] = cell->GetPointId(1);
		face[i][2] = cell->GetPointId(2);
	}
	mesh->generateVertexLink();
	mesh->generateFaceLink();

	//TRACE("Vertex#: %d\n", mesh->GetNumberOfPoints());
	//TRACE("Face  #: %d\n", mesh->GetNumberOfCells());
	smoother->setMeshData(mesh);
	subdivider->setMeshData(mesh);
	simplifier->setMeshData(mesh);

	this->last_vertex_N = 0;

	mesh->computeFaceNormal();
	mesh->computeNormal();
	for(i=0; i<mesh->vertex_N; i++)
		mesh->isFixed[i] = false;

	is_deformed = true;

	/************/
	//mesh->computeCenter();
	//mesh->computeVertexFromCenter();

	/************/
	/*
	implicit = new MeshData;
	implicit->copyMesh(mesh);
	implicit->computeNormal();
	implicit->computeFaceNormal();
	*/
	contour->Delete();
	sample->Delete();

	if(grid_dia->m_opt){
		clock_t finish = clock();
		double duration = (double)(finish - start) / CLOCKS_PER_SEC;
		if(auto_dia->DoModal() == IDOK){
			float tau = 0.001;
			if(auto_dia->m_large_tau)
				tau = 0.01;

			start = clock();
			smoother->generateUniformCenter(func, auto_dia->m_initial_dual+1, tau);		
			smoother->replaceOptimalPosition(500, all_dia->m_uni_w, all_dia->m_ave-1);
			for(int i=0; i<auto_dia->m_subdiv; i++){
				subdivider->subdivideCurvedFace(func, auto_dia->m_subdiv_e);
				smoother->setMeshData(mesh);

				smoother->generateUniformCenter(func, auto_dia->m_dual+1, tau);		
				smoother->replaceOptimalPosition(500, all_dia->m_uni_w, all_dia->m_ave-1);
			}

			if(auto_dia->m_decimation){
				for(int i=0; i<auto_dia->m_subdiv+1; i++){
					mesh->computeCenter();
					smoother->setCenterOnSurface(func);
					simplifier->simplifyImplicitMeshGarlandwithEn(auto_dia->m_deci_e, func);
					MeshData* new_mesh = new MeshData;
					new_mesh->copyMesh2(mesh);
					delete mesh;
					mesh = new_mesh;
					mesh->generateVertexLink();
					mesh->generateFaceLink();
					smoother->setMeshData(mesh);
					simplifier->setMeshData(mesh);
					subdivider->setMeshData(mesh);
					mesh->computeFaceNormal();	
				}
			}

			finish = clock();
			duration += (double)(finish - start) / CLOCKS_PER_SEC;
			time_dia->m_time = duration;
			time_dia->m_count = ((OurImplicitFunction*)func)->count;
		}
		mesh->computeFaceNormal();		
	}
	draw();
	if(!grid_dia->m_vox)
		return;

	VolumeFunction* vol = new VolumeFunction;
	float ori[] = {-20, -20, -20};
	float spa[3];
	int dims[3];
	dims[0] = dim;
	dims[1] = dim;
	dims[2] = dim;
	spa[0] = 40.0/dims[0];
	spa[1] = 40.0/dims[1];
	spa[2] = 40.0/dims[2];
	vol->setOriAndSpace(ori, spa);
	vol->setMaskSize(0.5);
	vol->setDim(dims);
	vol->sampleImplicitFunction(func);
	//vol->sampleImplicitValue(func);
	//vol->computeNabla();
	//vol->computeSimpleGradient();
	func->Delete();
	func = vol;
}

void CPolyTestDoc::drawMesh()
{
	if(mesh == NULL)
		return;

	//if(is_deformed)
		//mesh->computeFaceNormal();

	POSITION pos = GetFirstViewPosition();
	CPolyTestView* pView = (CPolyTestView*)GetNextView(pos);
	if(mode == 0)
		pView->flatShade(mesh);
	//else if(mode == 1) 
		//pView->wireFrame(mesh);
	else if(mode == 1){
		//pView->drawCenterGraph(mesh);
		pView->drawFixedVertex(mesh);
	}
	else if(mode == 2){
		pView->drawCenterGraph(mesh);
		//pView->drawSqrt3(mesh);
	}
	//pView->Invalidate(TRUE);	
	//pView->wireFrame(implicit);
}

void CPolyTestDoc::OnFileSaveAs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* dia = new CFileDialog(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, NULL);
	
	if(dia->DoModal() == IDOK){
		CString file_name = dia->GetPathName();
		FILE* file = fopen(file_name,"w");

		int f_N = mesh->countValidFace();
		int v_N = mesh->countValidVertex();
		int* vertex_table = new int[mesh->vertex_N];
		int counter = 0;

		float (*vertex)[3] = mesh->vertex;
		int (*face)[3] = mesh->face;
		int vertex_N = mesh->vertex_N;
		int face_N = mesh->face_N;

		fprintf(file, "%d\n", v_N);
		fprintf(file, "%d\n", f_N);
		for(int i=0; i<vertex_N; i++){
			if(mesh->degree_v[i] != 0){
				fprintf(file, "%f ", vertex[i][0]);
				fprintf(file, "%f ", vertex[i][1]);
				fprintf(file, "%f\n", vertex[i][2]);
				vertex_table[i] = counter;
				counter++;
			}
			else
				vertex_table[i] = -1;
		}
		for(i=0; i<face_N; i++){
			if(mesh->face[i][0] >= 0){
				fprintf(file, "3 ");
				fprintf(file, "%d ", vertex_table[face[i][0]]);
				fprintf(file, "%d ", vertex_table[face[i][1]]);
				fprintf(file, "%d\n", vertex_table[face[i][2]]);
			}
		}
		fclose(file);
		delete[] vertex_table;
	}
	delete dia;
}

void CPolyTestDoc::OnWire() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	mesh->computeFaceNormal();
	mesh->computeNormal();
	//smoother->setFixedVertex(s_dia->T, func);
	mode = 1;
/*
		mesh->computeNormal();
		mesh->computeCenter();
		smoother->setCenterOnSurface(func);
		smoother->center = mesh->center;
		smoother->valid = mesh->valid_f;
		smoother->m = mesh->normal_f;
		smoother->setCenterNormal(func);
		smoother->setVertexFromCenterW(1.0f);
		smoother->resolveFlip();
		mesh->computeFaceNormal();
		*/
	draw();
}

void CPolyTestDoc::OnSmooth() 
{
	
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(s_dia->DoModal() == IDOK){
		((OurImplicitFunction*)func)->count = 0;
		clock_t start = clock();
		if(s_dia->m_switch){
			smoother->correctImplicitSurfaceNew(func, s_dia->iteration, 
				s_dia->m_off_iter, s_dia->m_error);
		}
		else{
			smoother->correctImplicitSurface(func, s_dia->iteration, s_dia->m_off_iter,
				s_dia->T, s_dia->projection, s_dia->uniform, s_dia->keep, s_dia->m_error, 0); //this->last_vertex_N);
		}
		clock_t finish = clock();
		double duration = (double)(finish - start) / CLOCKS_PER_SEC;
		time_dia->m_time = duration;
		time_dia->m_count = ((OurImplicitFunction*)func)->count;
		time_dia->m_count = ((OurImplicitFunction*)func)->count;
		//smoother->correctImplicitSurfacePowell((OurImplicitFunction*)func);
		//smoother->correntImplicitCenter(func, s_dia->iteration);
		is_deformed = true;
		mesh->computeFaceNormal();
		mesh->computeNormal();
		draw();
	}
}

void CPolyTestDoc::OnFlat() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	mesh->computeFaceNormal();
	//smoother->setNormalAsGrad(func);
	mode = 0;
	draw();
}

void CPolyTestDoc::readVolData(CString file)
{
	//int dim[] = {64, 64, 93};
	int dim[] = {256, 256, 93};
	//int dim[] = {128, 128, 93};
	//int dim[] = {256, 256, 256};
	//int dim[] = {470, 500, 138};
	//int dimP[] = {128, 128, 46};
	int rate = 2;
	float origin[] = {0, 0, 0};
	//float space[] = {0.16, 0.16, 0.15};
	//float space[] = {0.08, 0.08, 0.08};
	float space[] = {0.08, 0.08, 0.15};
	//float space[] = {0.32, 0.32, 0.15};
	int i;
	

	//for born
	float iso = 1150;
	
	//for face
	//float iso = 500;

	//float iso = 50000;

	vtkVolume16Reader *v16 = vtkVolume16Reader::New();
	v16->SetDataDimensions(dim[0],dim[1]);
	v16->SwapBytesOn();
	v16->SetFilePrefix(file);
	v16->GetOutput()->SetOrigin(origin[0], origin[1], origin[2]);
	v16->SetDataByteOrderToLittleEndian();
	v16->SetImageRange(1,dim[2]);
	v16->SetDataSpacing(space[0], space[1], space[2]);
	v16->Update();

	vtkImageShrink3D *shrinker = vtkImageShrink3D::New();
	shrinker->GetOutput()->SetOrigin(origin[0], origin[1], origin[2]);
	shrinker->SetInput(v16->GetOutput());
	shrinker->SetShrinkFactors(rate, rate, rate);
	//shrinker->AveragingOn();
	shrinker->AveragingOff();
	shrinker->Update();

	/*
	vtkImageClip *clip = vtkImageClip::New();
	clip->GetOutput()->SetOrigin(origin[0], origin[1], origin[2]);
	//clip->GetOutput()->SetDataSpacing(space[0], space[1], space[2]);
	clip->SetInput(shrinker->GetOutput());
	clip->SetOutputWholeExtent(0, 32, 0, 64, 0, 46);
	clip->ClipDataOn();
	clip->Update();*/

	/************************************

	vtkStructuredPoints* low = vtkStructuredPoints::New();
	low->SetDimensions(dimP[0], dimP[1], dimP[2]);
	low->SetOrigin(origin[0], origin[1], origin[2]);
	low->SetSpacing(space[0]*dim[0]/dimP[0], space[1]*dim[1]/dimP[1], space[2]*dim[2]/dimP[2]);
	vtkFloatScalars *value = vtkFloatScalars::New();
	value->Allocate(dimP[0] * dimP[1] * dimP[2]);
	int offset = 0;
	for(i=0; i<dimP[2]; i++){
		for(int j=0; j<dimP[1]; j++){
			for(int k=0; k<dimP[0]/2; k++){
				float p[3];
				p[0] = origin[0] + space[0]*dim[0]*k/dimP[0];
				p[1] = origin[1] + space[1]*dim[1]*j/dimP[1];
				p[2] = origin[2] + space[2]*dim[2]*i/dimP[2];
				value->InsertScalar(offset, vol_f->EvaluateFunction(p));
				offset++;
			}
		}
	}
	low->GetPointData()->SetScalars(value);
	value->Delete();

	**********************************************/
	

	vtkContourFilter *contour = vtkContourFilter::New();
	//vtkMarchingCubes *contour = vtkMarchingCubes::New();
	//contour->SetInput(low);
	contour->SetInput(shrinker->GetOutput());
	//contour->SetInput(clip->GetOutput());
	//contour->GenerateValues(1, 0, 0);
	contour->GenerateValues(1,iso, iso);
	contour->Update();
	shrinker->Delete();

	vtkPolyData *mesh_data = contour->GetOutput();

	if(mesh != NULL)
		delete mesh;
	mesh = new MeshData;

	int vertex_N = mesh_data->GetNumberOfPoints();
	mesh->setVertexCount(vertex_N);

	for(i=0; i<vertex_N; i++){
		mesh_data->GetPoint(i, mesh->vertex[i]);
	}

	int poly_N = mesh_data->GetNumberOfCells();
	mesh->setFaceCount(poly_N);

	int (*face)[3] = mesh->face;
	for(i=0; i<poly_N; i++){
		vtkCell* cell = mesh_data->GetCell(i);
		face[i][0] = cell->GetPointId(0);
		face[i][1] = cell->GetPointId(1);
		face[i][2] = cell->GetPointId(2);
	}

	contour->Delete();
	//low->Delete();
	mesh->computeFaceNormal();
	//draw();

	vtkStructuredPoints* full = v16->GetOutput();
	vtkScalars* full_value = full->GetPointData()->GetScalars();
	VolumeFunction* vol_f = new VolumeFunction;
	vol_f->setMaskSize(2.0f);
	vol_f->setDim(dim);
	vol_f->setOriAndSpace(origin, space);
	float*** f_value = vol_f->value;
	for(i=0; i<dim[2]; i++)
		for(int j=0; j<dim[1]; j++)
			for(int k=0; k<dim[0]; k++)
				f_value[i][j][k] = full_value->GetScalar(i*dim[1]*dim[0] + j*dim[0]+k) - iso;
	v16->Delete();
	func = vol_f;
	vol_f->reflectData();
	//vol_f->thresholding(100);
	//vol_f->GaussSmoothing();
	vol_f->computeNabla();
	//vol_f->averageGradient(5, 1.0f);
	//vol_f->computeSimpleGradient();

	//mesh = vol_f->generateMesh(rate);
}

void CPolyTestDoc::OnVol() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	//readVolData("E:/d8011101/experiment/headsq/quarter");
	//readVolData("E:/d8011101/experiment/headsq/half");
	//readMRData("E:/d8011101/Math/vol_data/sphere100");
	//readVolData("E:/d8011101/experiment/fullHead/headsq");
	//readVolData("D:/d8011101/experiment/VOLUME/fullHead/headsq");
	//readVolData("E:/d8011101/experiment/pineRoot/pine_root");
	//readMRData("E:/d8011101/experiment/frog/frog");
	//readMRData("C:/d8011101/experiment/VOLUME/frog/frog");
	//readMRData("C:/d8011101/experiment/VOLUME/frog/frogTissue");
	//readMRData("E:/d8011101/experiment/frog/frogTissue");
	//readMRData("C:/d8011101/experiment/VOLUME/vol_data/2holeS50");
	//readMRData("D:/d8011101/experiment/VOLUME/vol_data/dodeka100");
	readMRData("C:/d8011101/experiment/VOLUME/vol_data/4meta50");
	//readMRData("C:/d8011101/experiment/VOLUME/vol_data/sphere50");

	mesh->generateVertexLink();
	mesh->generateFaceLink();

	/*
	mesh->largestComponent();
	mesh->generateVertexLink();
	mesh->generateFaceLink();
	*/

	mesh->computeFaceNormal();
	mesh->computeNormal();

	smoother->setMeshData(mesh);
	subdivider->setMeshData(mesh);
	simplifier->setMeshData(mesh);

	this->last_vertex_N = 0;

	mesh->computeFaceNormal();
	for(int i=0; i<mesh->vertex_N; i++)
		mesh->isFixed[i] = false;

	/*
	int deg6 = 0;
	for(i=0; i<mesh->vertex_N; i++)
		if(mesh->degree_v[i] == 6)
			deg6++;
	TRACE("%f\n",(float)deg6/mesh->countValidVertex()); 
	*/

	is_deformed = true;
	draw();
}

void CPolyTestDoc::OnFileOpen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* dia = new CFileDialog(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, file_ex, NULL);
	
	if(dia->DoModal() == IDOK){
		if(mesh != NULL)
			delete mesh;
		mesh = new MeshData;

		if(func == NULL)
			func = new OurImplicitFunction;

		CString file_name = dia->GetPathName();
		CString file_ext = dia->GetFileExt();
		FILE* file = fopen(file_name,"r");

		//Read mesh data from file 
		//and create adjacent data for the mesh
		FileManager file_manager;
		file_manager.setFile(file, file_name, file_ext);
		file_manager.open(mesh);

		fclose(file);

		smoother->setMeshData(mesh);
		subdivider->setMeshData(mesh);
		simplifier->setMeshData(mesh);
		
		mesh->computeFaceNormal();
		mesh->computeNormal();

		this->last_vertex_N = 0;

		is_deformed = true;
		this->draw();
	}
	delete dia;
}

void CPolyTestDoc::OnSubdivide() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(mesh != NULL){
		this->last_vertex_N = mesh->vertex_N;
		subdivider->subdivideCurvedFace(func, 0.0005);
		smoother->setMeshData(mesh);
		//subdivider->subdivideInside(func);
		is_deformed = true;
		this->draw();
	}
}

void CPolyTestDoc::OnSimplify() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(deci_dia->DoModal() == IDOK){
		mesh->computeFaceNormal();
		mesh->computeCenter();
		smoother->setCenterOnSurface(func);
		//smoother->setNormalAsGraCeneter(func);
		if(deci_dia->m_type == 0){
			simplifier->simplifyImplicitMeshGarlandwithEn(deci_dia->m_T, func);
			//simplifier->Garland(deci_dia->m_T, func, false);
			//simplifier->simplifyImplicitMesh(deci_dia->m_T, func);
		}
		else{
			((OurImplicitFunction*)func)->count = 0;
			//simplifier->simplifyImplicitMesh3(deci_dia->m_T, func, false);
			simplifier->simplifyImplicitMeshGarand(deci_dia->m_T, func, false);
			//simplifier->Garland(deci_dia->m_T, func, false);
			//simplifier->simplifyImplicitMeshGarlandwithEn(0.001, func);
			time_dia->m_count = ((OurImplicitFunction*)func)->count;
		}
		MeshData* new_mesh = new MeshData;
		new_mesh->copyMesh2(mesh);
		delete mesh;
		mesh = new_mesh;
		mesh->generateVertexLink();
		mesh->generateFaceLink();
		smoother->setMeshData(mesh);
		simplifier->setMeshData(mesh);
		subdivider->setMeshData(mesh);
		mesh->computeFaceNormal();
		mesh->computeNormal();

		this->last_vertex_N = mesh->vertex_N;

		is_deformed = true;
		this->draw();
	}
}


void CPolyTestDoc::draw()
{
	POSITION pos = GetFirstViewPosition();
	CPolyTestView* pView = (CPolyTestView*)GetNextView(pos);
	if(is_deformed){
		//mesh->computeFaceNormal();
		pView->face_N = mesh->countValidFace();
		pView->vertex_N = mesh->countValidVertex();
		pView->f_err = smoother->computeFaceNormalErr(func);
		//pView->f_err = smoother->computeMaxFaceNormalErr(func);
		pView->v_err = smoother->computeVertexErr(func);
		//pView->v_err = smoother->computeMaxVertexErr(func);
	}
	pView->draw();
}

void CPolyTestDoc::readMRData(CString file)
{
	//int dim[] = {500, 470, 138};
	//int dimP[] = {500, 470, 138};

	//int size[] = {500, 470, 138};
	//int size[] = {100, 100, 100};
	//int size[] = {100,100,100};
	int size[] = {50,50,50};

	//int dim[] = {456, 462, 137};
	//int dimP[] = {456, 462, 137};
	float origin[] = {-10, -10, -10};
	//float space[] = {0.05, 0.05, 0.075};

	int start[] = {0,0,0};
	//int start[] = {50, 30, 10};
	//int start[] = {23,8,0};

	//int dim[] = {100,100,100};
	//int dim[] = {100,100,50};
	int dim[] = {50,50,50};
	//int dimP[] = {100,100,100};
	//int dimP[] = {20, 20, 5};
	int dimP[] = {50,50,50};
	float space[] = {0.5,0.5,0.5};
	//float space[] = {1.5,1.5,1.5};

	//float iso = 255;
	float iso = 125;
	//float iso = 50;
	//float iso = 1;

	//float iso = 13;
	
	VolumeFunction* vol_f = new VolumeFunction;
	vol_f->setMaskSize(2.0f);
	vol_f->setDim(dim);
	vol_f->setOriAndSpace(origin, space);
	float*** f_value = vol_f->value;

	//read data
	for(int i=0; i<dim[2]; i++){
		int** I = NULL;
		int X, Y;
		CString num;
		num.Format(".%d", start[2]+i+1);
		readPGM(file + num, I, X, Y);

		for(int j=0; j<dim[1]; j++)
			for(int k=0; k<dim[0]; k++)
				f_value[i][j][k] = (float)I[j+start[1]][k+start[0]] - iso;

		for(j=0; j<size[1]; j++)
			delete[] I[j];
		delete[] I;
	}

	//vol_f->thresholding();

	//mesh = vol_f->generateMesh();
	//return;
//vol_f->GaussSmoothing();
	vtkStructuredPoints* low = vtkStructuredPoints::New();
	low->SetDimensions(dimP[0], dimP[1], dimP[2]);
	low->SetOrigin(origin[0], origin[1], origin[2]);
	low->SetSpacing(space[0]*dim[0]/dimP[0], space[1]*dim[1]/dimP[1], space[2]*dim[2]/dimP[2]);
	vtkFloatScalars *value = vtkFloatScalars::New();
	value->Allocate(dimP[0] * dimP[1] * dimP[2]);
	int offset = 0;
	for(i=0; i<dimP[2]; i++){
		for(int j=0; j<dimP[1]; j++){
			for(int k=0; k<dimP[0]; k++){
				float p[3];
				p[0] = origin[0] + space[0]*dim[0]*k/dimP[0];
				p[1] = origin[1] + space[1]*dim[1]*j/dimP[1];
				p[2] = origin[2] + space[2]*dim[2]*i/dimP[2];
				value->InsertScalar(offset, vol_f->EvaluateFunction(p));
				offset++;
			}
		}
	}
	low->GetPointData()->SetScalars(value);
	low->Update();
	value->Delete();

	vtkContourFilter *contour = vtkContourFilter::New();
	//vtkMarchingCubes *contour = vtkMarchingCubes::New();
	contour->SetInput(low);
	contour->GenerateValues(1, 0, iso);
	contour->Update();

	vtkPolyData *mesh_data = contour->GetOutput();

	if(mesh != NULL)
		delete mesh;
	mesh = new MeshData;

	int vertex_N = mesh_data->GetNumberOfPoints();
	mesh->setVertexCount(vertex_N);

	for(i=0; i<vertex_N; i++){
		mesh_data->GetPoint(i, mesh->vertex[i]);
	}

	int poly_N = mesh_data->GetNumberOfCells();
	mesh->setFaceCount(poly_N);

	int (*face)[3] = mesh->face;
	for(i=0; i<poly_N; i++){
		vtkCell* cell = mesh_data->GetCell(i);
		face[i][0] = cell->GetPointId(0);
		face[i][1] = cell->GetPointId(1);
		face[i][2] = cell->GetPointId(2);
	}

	contour->Delete();
	low->Delete();

	//compute nabla 
	vol_f->reflectData();
	//vol_f->GaussSmoothing();
	vol_f->computeNabla();
	//vol_f->computeSimpleGradient();
	//vol_f->averageGradient2(10, 0.0f);
	//vol_f->GaussSmoothing();
	func = vol_f;
	//mesh = vol_f->generateMesh();
}

void CPolyTestDoc::readPGM(CString file, int **&I, int &X, int &Y)
{
	int i,j;
	int k, kk;
	char buffer[10];
	FILE *ipst;  /* InPut STream */

	ipst = fopen(file, "r");
	if (!ipst){
		fprintf(stderr, "Can't open the pgm file %s\n", buffer);
		exit(0);
	}

	fscanf(ipst,"%s",buffer);

	/* skip comment lines if exists */
	k = getc(ipst);
	while ((kk=getc(ipst)) == '#') {
		i = -1;
		fprintf(stderr,"\nfile = ");
		do {
			i++;
			k = getc(ipst);
        }while (k != '\n');
    }
	if (kk != '#') ungetc(kk,ipst);
  
	fscanf(ipst,"%d",&X);
	fscanf(ipst,"%d",&Y);

	/* 摜̎,  */
	I = new int*[Y];
	for(i=0; i<Y; i++)
		I[i] = new int[X];

	int max;
	fscanf(ipst,"%d",&max);

    
	/* Pxl̓ǂݍ */
	if (buffer[1] == '5'){
		/* P5t@CioCif[^j̓ǂݍ */
		unsigned char* tmp = new unsigned char[Y*X];
		fread(tmp, sizeof(unsigned char), Y*X, ipst);

		for(i=0; i<Y; i++){
			for(j=0; j<X; j++){
				I[i][j] = (int)tmp[i*X+j];
			}
		}
		delete[] tmp;
    }
	else {
		/* P2t@CiAXL[f[^j̓ǂݍ */
		for(int i=0; i<Y; i++)
			for(int j=0; j<X; j++){
				fscanf(ipst, "%d", &(I[i][j]));
			}
    }
	fclose(ipst);
}


void CPolyTestDoc::OnEngrave() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(s_dia->DoModal() == IDOK){
		smoother->moveImplicit(func, s_dia->iteration, false);
		is_deformed = true;
		draw();
	}
}

void CPolyTestDoc::OnNabla() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	smoother->setNormalAsGrad(func);
	mode = 0;
	draw();
}

void CPolyTestDoc::OnUniform() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(uni_dia->DoModal() == IDOK){
		smoother->generateUniformCenter(func, uni_dia->m_iteration, uni_dia->m_weight);

		mesh->computeFaceNormal();
		mesh->computeNormal();
	}
	draw();
}

void CPolyTestDoc::OnOpt() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	smoother->replaceOptimalPosition(500, 0.001, 0);

	//mesh->computeFaceNormal();
	//mesh->computeNormal();
	OnFlat();
	//draw();
}

void CPolyTestDoc::OnCentr() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	mode = 2;

	if(smoother->center == NULL)
		mesh->computeCenter();
	else{
		mesh->computeCenter();
		smoother->setCenterOnSurface(func);

		//mesh->center = smoother->center;
		//mesh->normal_f = smoother->m;
	}
	mesh->computeNormal();

	draw();
}

void CPolyTestDoc::OnFlip() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ

	simplifier->deleteFlipTriangle(func);
	MeshData* new_mesh = new MeshData;
	new_mesh->copyMesh2(mesh);
	delete mesh;
	mesh = new_mesh;
	mesh->generateVertexLink();
	mesh->generateFaceLink();
	smoother->setMeshData(mesh);
	simplifier->setMeshData(mesh);
	subdivider->setMeshData(mesh);
	mesh->computeFaceNormal();
	mesh->computeNormal();

	this->last_vertex_N = mesh->vertex_N;

	is_deformed = true;
	this->draw();
}

void CPolyTestDoc::OnTogether() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(all_dia->DoModal() == IDOK){
		smoother->generateUniformCenter(func, all_dia->m_iteration, all_dia->m_weight);		
		smoother->replaceOptimalPosition(500, all_dia->m_uni_w, all_dia->m_ave-1);

		if(all_dia->m_flip){
			simplifier->deleteFlipTriangle(func);
			MeshData* new_mesh = new MeshData;
			new_mesh->copyMesh2(mesh);
			delete mesh;
			mesh = new_mesh;
			mesh->generateVertexLink();
			mesh->generateFaceLink();
			smoother->setMeshData(mesh);
			simplifier->setMeshData(mesh);
			subdivider->setMeshData(mesh);
			this->last_vertex_N = mesh->vertex_N;
		}
		mesh->computeFaceNormal();
		mesh->computeNormal();
	}

	is_deformed = true;
	this->draw();
}

void CPolyTestDoc::OnCompT() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	time_dia->DoModal();
}

void CPolyTestDoc::OnRbf() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFileDialog* dia = new CFileDialog(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, NULL);
	
	if(dia->DoModal() == IDOK){
		CString file_name = dia->GetPathName();
		FILE* file = fopen(file_name,"r");

		if(file == NULL)
			return;

		RadialBasisFunction* func = new RadialBasisFunction;

		BOOL isAscii;
		int centerN = 0;
		while(true){
			char s[1000];
			fscanf(file, "%s", s);
			CString line(s);	
			if("Centres" == line){
				CString token;
				fscanf(file, "%s", token);
				fscanf(file, "%s", token);
				char num[100];
				fscanf(file, "%s", num);
				int n = 0;
				int i = 0;
				while(true){
					char ch = num[i++];
					if(ch  == ';')
						break;
					n = n*10 + ch - (int)'0';
				}
				centerN = n;
			}
			else if("[ascii]" == line){
				isAscii = true;
				break;
			}
			else if("[binary]" == line){
				isAscii = false;
				break;
			}
		}
		if(!isAscii)
			return;

		double dummy;
		fscanf(file, "%lf", &dummy);
		func->setCenterN(centerN);
		double (*center)[3] = func->center;
		double *coefficient = func->coefficient;
		double *low_poly = func->low_poly;
		for(int i=0; i<centerN; i++){
			fscanf(file, "%lf", &center[i][0]);
			fscanf(file, "%lf", &center[i][1]);
			fscanf(file, "%lf", &center[i][2]);
		}
	
		for(i=0; i<centerN; i++){
			fscanf(file, "%lf", &coefficient[i]);
		}
		fscanf(file, "%lf", &low_poly[3]);
		fscanf(file, "%lf", &low_poly[0]);
		fscanf(file, "%lf", &low_poly[1]);
		fscanf(file, "%lf", &low_poly[2]);
	
		double max[3], min[3];
		for(i=0; i<3; i++)
			fscanf(file, "%lf", &min[i]);
		for(i=0; i<3; i++)
			fscanf(file, "%lf", &max[i]);

		fclose(file);

		this->func = func;

		float size = 0;
		float origin[3];
		for(i=0; i<3; i++){
			origin[i] = 0.5*(max[i] + min[i]);
			double s = 0.5*(max[i] - min[i]);
			if(size < s)
				size = s;
		}
		func->setBound(origin, size);

		if(!func->isDirect){
			int level = 6;
			func->setOctTree(level);
		}


		int dim;
		if(grid_dia->DoModal() == IDOK)
			dim = grid_dia->m_grid;
		else
			return;

		clock_t start = clock();

		vtkSampleFunction *sample = vtkSampleFunction::New();
		sample->SetSampleDimensions(dim,dim,dim);
		sample->SetModelBounds(min[0],max[0],min[1],max[1],min[2],max[2]);
		sample->SetImplicitFunction(func);
		sample->ComputeNormalsOff();
		sample->Update();

		vtkContourFilter *contour = vtkContourFilter::New();
		contour->SetInput(sample->GetOutput());
		contour->GenerateValues(1, 0, 0);
		contour->Update();

		vtkPolyData *mesh_data = contour->GetOutput();

		if(mesh != NULL)
			delete mesh;
		mesh = new MeshData;

		int vertex_N = mesh_data->GetNumberOfPoints();
		mesh->setVertexCount(vertex_N);

		for(i=0; i<vertex_N; i++){
			mesh_data->GetPoint(i, mesh->vertex[i]);
		}

		int poly_N = mesh_data->GetNumberOfCells();
		mesh->setFaceCount(poly_N);

		int (*face)[3] = mesh->face;
		for(i=0; i<poly_N; i++){
			vtkCell* cell = mesh_data->GetCell(i);
			face[i][0] = cell->GetPointId(0);
			face[i][1] = cell->GetPointId(1);
			face[i][2] = cell->GetPointId(2);
		}
		mesh->generateVertexLink();
		mesh->generateFaceLink();

		smoother->setMeshData(mesh);
		subdivider->setMeshData(mesh);
		simplifier->setMeshData(mesh);

		this->last_vertex_N = 0;

		mesh->computeFaceNormal();
		mesh->computeNormal();
		for(i=0; i<mesh->vertex_N; i++)
			mesh->isFixed[i] = false;

		is_deformed = true;

		contour->Delete();
		sample->Delete();

		if(grid_dia->m_opt){
			if(auto_dia->DoModal() == IDOK){
				float tau = 0.001;
				if(auto_dia->m_large_tau)
					tau = 0.01;

				start = clock();
				smoother->generateUniformCenter(func, auto_dia->m_initial_dual+1, tau);		
				smoother->replaceOptimalPosition(500, all_dia->m_uni_w, all_dia->m_ave-1);
				for(int i=0; i<auto_dia->m_subdiv; i++){
					subdivider->subdivideCurvedFace(func, auto_dia->m_subdiv_e);
					smoother->setMeshData(mesh);

					smoother->generateUniformCenter(func, auto_dia->m_dual+1, tau);		
					smoother->replaceOptimalPosition(500, all_dia->m_uni_w, all_dia->m_ave-1);
				}

				if(auto_dia->m_decimation){
					for(int i=0; i<auto_dia->m_subdiv+1; i++){
						mesh->computeCenter();
						smoother->setCenterOnSurface(func);
						simplifier->simplifyImplicitMeshGarlandwithEn(auto_dia->m_deci_e, func);
						MeshData* new_mesh = new MeshData;
						new_mesh->copyMesh2(mesh);
						delete mesh;
						mesh = new_mesh;
						mesh->generateVertexLink();
						mesh->generateFaceLink();
						smoother->setMeshData(mesh);
						simplifier->setMeshData(mesh);
						subdivider->setMeshData(mesh);
						mesh->computeFaceNormal();	
					}
				}
			}
			mesh->computeFaceNormal();		
		}
		draw();
	}
}

void CPolyTestDoc::OnSilver() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	simplifier->eliminateSilverTriangle(0.5f);
	is_deformed = true;
	draw();
}
