// PolyTestDoc.h : CPolyTestDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYTESTDOC_H__2868D713_5098_46AD_9B93_0D44100D2806__INCLUDED_)
#define AFX_POLYTESTDOC_H__2868D713_5098_46AD_9B93_0D44100D2806__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <time.h>

#include "MeshData.h"
#include "Smoother.h"
#include "Subdivider.h"
#include "SmoothDialog.h"
#include "DecimationDialog.h"
#include "UniformDialog.h"
#include "AllDialog.h"
#include "GridDialog.h"
#include "Simplifier.h"
#include "vtkImplicitFunction.h"
#include "TimeDialog.h"
#include "AutoOptDialog.h"
#include "RadialBasisFunction.h"

class CPolyTestDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CPolyTestDoc();
	DECLARE_DYNCREATE(CPolyTestDoc)

// Agr[g
public:
	MeshData* implicit;
	MeshData* mesh;
	Smoother* smoother;
	Subdivider* subdivider;
	Simplifier* simplifier;
	SmoothDialog* s_dia;
	GridDialog* grid_dia;
	AllDialog* all_dia;
	TimeDialog* time_dia;
	UniformDialog* uni_dia;
	DecimationDialog* deci_dia;
	AutoOptDialog* auto_dia;
	vtkImplicitFunction* func;
	int last_vertex_N;
	BOOL is_deformed;

// Iy[V
public:

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPolyTestDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Cve[V
public:
	void readMRData(CString file);
	void drawMesh();
	virtual ~CPolyTestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	int mode;

// ꂽbZ[W }bv֐
protected:
	void readPGM(CString file, int **&I, int &X, int &Y);
	void draw();
	void readVolData(CString file);
	//{{AFX_MSG(CPolyTestDoc)
	afx_msg void OnPolygonize();
	afx_msg void OnFileSaveAs();
	afx_msg void OnWire();
	afx_msg void OnSmooth();
	afx_msg void OnFlat();
	afx_msg void OnVol();
	afx_msg void OnFileOpen();
	afx_msg void OnSubdivide();
	afx_msg void OnSimplify();
	afx_msg void OnEngrave();
	afx_msg void OnNabla();
	afx_msg void OnUniform();
	afx_msg void OnOpt();
	afx_msg void OnCentr();
	afx_msg void OnFlip();
	afx_msg void OnTogether();
	afx_msg void OnCompT();
	afx_msg void OnRbf();
	afx_msg void OnSilver();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_POLYTESTDOC_H__2868D713_5098_46AD_9B93_0D44100D2806__INCLUDED_)
