// RadialBasisFunction.h: RadialBasisFunction NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RADIALBASISFUNCTION_H__4BCE223A_D927_4203_87A7_9817D5024804__INCLUDED_)
#define AFX_RADIALBASISFUNCTION_H__4BCE223A_D927_4203_87A7_9817D5024804__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vtkImplicitFunction.h"

class RadialBasisFunction : public vtkImplicitFunction  
{
	struct Cell{
		Cell  *parent;
		Cell *child[8];
		int level;
		float o[3];
		float size;

		BOOL isChild;
		int *c_index;
		int c_N;

		double coeff[20];	
	};

public:
	int center_N;
	double (*center)[3];
	double *coefficient;
	double *low_poly;
	float bound_size;
	float origin[3];
	BOOL isDirect;

private:
	void initCell(RadialBasisFunction::Cell *&c, int level, int max_level, float o[3]);
	Cell* root;
	float (*o_his)[3];

public:
	void evaluateRBFD(float x[3], float* g, Cell* current);
	void traceTree(float x[3], Cell* current);
	float evaluateRBF(float x[3], Cell* current);
	int computeCellRBF(Cell* current);
	void insertCenter(int index, Cell* current);
	void initCenterIndex(Cell* current);
	void countCenterIndex(int index, Cell* current);
	void setBound(float o[3], float size);
	void setCenterN(int center_N);
	void EvaluateGradient(float x[3], float g[3]);
	float EvaluateFunction(float x[3]);
	RadialBasisFunction();
	virtual ~RadialBasisFunction();
	void setOctTree(int level);
};

#endif // !defined(AFX_RADIALBASISFUNCTION_H__4BCE223A_D927_4203_87A7_9817D5024804__INCLUDED_)
