// VolumeFunction.h: VolumeFunction NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VOLUMEFUNCTION_H__01DEF021_5731_4C25_8483_F3714257A236__INCLUDED_)
#define AFX_VOLUMEFUNCTION_H__01DEF021_5731_4C25_8483_F3714257A236__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "vtkImplicitFunction.h"
#include "MeshData.h"
#include <math.h>

#define h 0.0001

class VolumeFunction : public vtkImplicitFunction  
{
public:
	float spaceX, spaceY, spaceZ;
	int dimX, dimY, dimZ;
	float originX, originY, originZ;
	float ***value;
	double *mask;
	int mask_size;
	float (***nabla)[3];
	int ***dist;

public:
	MeshData* generateMesh(int sh);
	void sampleImplicitValue(vtkImplicitFunction *func);
	void sampleImplicitFunction(vtkImplicitFunction* func);
	MeshData* generateMesh();
	void generateDist(int max_dist);
	void averageGradient3(int iter, float T);
	void averageGradient2(int iter, float T);
	void averageGradient(int iter, float T);
	void computeSimpleGradient();
	void thresholding();
	void GaussSmoothing();
	void computeNablaZ(float ***I);
	void computeNablaX(float ***I);
	void convoluteZ(float ***I);
	void convoluteY(float ***I);
	void computeNabla();
	void reflectData();
	void setMaskSize(float T);
	void computGradientAtP(int ix, int iy, int iz, float g[]);
	void setOriAndSpace(float origin[], float space[]);
	void setDim(int dim[3]);
	VolumeFunction();
	virtual ~VolumeFunction();
	void EvaluateGradient(float x[], float g[]);
	float EvaluateFunction(float x[]);

	static inline void VolumeFunction::INTER(float v[3], float v1[3], float v2[3], float f)
	{
		v[0] = v1[0] + f*(v2[0] - v1[0]);
		v[1] = v1[1] + f*(v2[1] - v1[1]);
		v[2] = v1[2] + f*(v2[2] - v1[2]);
	}
protected:
	void computeNablaY(float ***I);
	void convoluteX(float ***I);
};
#endif // !defined(AFX_VOLUMEFUNCTION_H__01DEF021_5731_4C25_8483_F3714257A236__INCLUDED_)
